// $Id: ActionSetMultiplicity.java,v 1.8 2005/01/09 14:59:02 linus Exp $
// Copyright (c) 1996-2005 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation without fee, and without a written
// agreement is hereby granted, provided that the above copyright notice
// and this paragraph appear in all copies.  This software program and
// documentation are copyrighted by The Regents of the University of
// California. The software program and documentation are supplied "AS
// IS", without any accompanying services from The Regents. The Regents
// does not warrant that the operation of the program will be
// uninterrupted or error-free. The end-user understands that the program
// was developed for research purposes and is advised not to rely
// exclusively on the program for any reason.  IN NO EVENT SHALL THE
// UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
// SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
// ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
// THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
// PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
// UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

// $Id: ActionSetMultiplicity.java,v 1.8 2005/01/09 14:59:02 linus Exp $
package org.argouml.uml.ui;

import java.awt.event.ActionEvent;

import org.argouml.i18n.Translator;

/**
 * Framework action to set the multiplicity of some modelelement.
 * @author jaap.branderhorst@xs4all.nl
 * @since Jan 6, 2003
 */
public abstract class ActionSetMultiplicity extends UMLAction {

    /**
     * Constructor for ActionSetMultiplicity.
     */
    protected ActionSetMultiplicity() {
        super(Translator.localize("Set"), true, NO_ICON);
    }

    /**
     * @see
     * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        Object source = e.getSource();
        if (source instanceof UMLComboBox2) {
            Object selected = ((UMLComboBox2) source).getSelectedItem();
            Object target = ((UMLComboBox2) source).getTarget();
            if (target != null && selected != null)
                setSelectedItem(selected, target);
        }
    }

    /**
     * The user should implement this method to set the multiplicity (the given
     * item) for the target of the comboboxmodel (target
     * @param item The multiplicity that should be set
     * @param target The target of the comboboxmodel (the modelelement that
     * should have its multiplicity set).
     */
    public abstract void setSelectedItem(Object item, Object target);

}
